#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <string.h>

int roky[3000];

bool priestupny( int y )
{
    return ( !(y%4) && (y%100)) || !(y%400);
}

void oznac( bool* bus, int y, int d )
{
		int start = -1;
		for ( int i=0; i<7; i++ )
		    if ( (roky[y]+i)%7 == d ) {
			start = i;
			break;
		    }
		for ( int i=start; i<366; i+=7 )
		    bus[i] = true;
}

int vn( int y )
{
    int golden = (y%19) + 1;
    int solar = (y-1600)/100 - (y-1600)/400;
    int lunar = (((y-1400)/100)*8)/25;
    int p = (3003-11*golden+solar-lunar)%30;
    if ( p == 29 || (p==28 && golden > 11 ))
	p--;
    return p;
}

void ons( bool * bus, int d )
{
    if ( ( (d+rok[y])%7 != 5 ) && ( (d+rok[y])%7 != 4 ) ) {
	bus[d+1] = true;
    }
}

void oznacw( bool *bus, int y, bool sviatky, bool p )
{
    
			bus[0] = bus[p+120] = bus[p+127] = bus[p+185] = sviatky;
			bus[p+186] = bus[p+270] = bus[p+300] = bus[p+320] = sviatky;
			bus[p+357] = bus[p+358] = bus[p+359] =  sviatky;
			bus[p+79+vn(y)] = sviatky;
			if ( sviatky )
			    oznac( bus, y, 6 );
}

void oznaca( bool *bus, int y, bool sviatky, bool p )
{
    ons( bus, 0 );
    ons( bus, p+120 );
    ons( bus, p+127 );
    ons( bus, p+185 );
    ons( bus, p+270);
    ons( bus, p+186);
    ons( bus, p+320);
    ons( bus, p+300);
    ons( bus, p+359);
    ons( bus, p+358);
    ons( bus, p+357);
    ons( bus, p+79+vn(y) );
    oznac( bus, y, 0 );
}

int main(int argc, char** argv)
{
    int d = 5;
    roky[1600] = d;
    for ( int i=1601; i<=3000; i++ ) {
	d = (d + 7 + 1)%7;
	if ( priestupny(i) )
	    d = (d + 7 + 1)%7;
	roky[i] = d;
    }
    char s[1000], r[2000];
    int y;
    while ( scanf( "%s %s %d", s, r, &y ) ) {
	bool bus[400];
	memset( bus, sizeof(bus), 0 );
	bool p = priestupny( y );
	char* ptr = s;
	bool oznacitSviatky = false;
	while ( *ptr ) {
	    if ( ( *ptr <= '7' ) && ( *ptr >= '1' ) ) {
		oznac( bus, y, *ptr - '0' - 1 );
	    } else {
		switch ( *ptr ) {
		    case 't':
			oznacitSviatky = true;
			break;
		    case 'w':
			for ( int i=0; i<5; i++ )
			    oznac( bus, y, i);
			oznacw( bus, y, false, p );
		    case 'a':
			oznaca( bus, y, true, p );
			break;
		}
	    }
	    ptr++;
	}
	if ( oznacitSviatky )
	    oznacw( bus, y, true, p );
    }
    return 0;
}

