#include <stdio.h>
#include <utility>
#include <algorithm>

using std::max;

bool r[20000], s[20000], d1[20000+20000], d2[20000+20000];

void reset( int x, int y )
{
    for ( int i=0; i<20000; i++ )
	r[i] = s[i] = d1[i] = d2[i] = false;
    for ( int i=20000; i<40000; i++ )
	d1[i] = d2[i] = false;
/*
    for ( int i=0; i<max(x,y); i++ ) {
	r[i] = false;
	s[i] = false;
	d1[i] = false;
	d2[i] = false;
    }
    for ( int i = max(x,y); i<x+y-1; i++ )
	d1[i] = d2[i] = false;
*/
}

int main(int argc, char** argv)
{
    int x, y, n;
    scanf( "%d %d %d\n", &x, &y, &n );
    while ( x || y || n ) {
	reset( x, y );
	for ( int k=0; k<n; k++ ) {
	    int a, b;
	    scanf( "%d %d\n", &a, &b );
	    a--;
	    b--;
	    r[a] = s[b] = d1[a+b] = d2[x-1-a+b] = true;
	}
	int count = 0;
	for ( int i=0; i<x; i++ ) {
	    if ( !r[i] ) {
		for ( int j=0; j<y; j++ ) {
		    if ( !s[j] && !d1[i+j] && !d2[x-1-i+j] ) {
			count++;
		    }
		}
	    }
	}
	printf( "%d\n", count );
	scanf( "%d %d %d\n", &x, &y, &n );
    }
    return 0;
}

